Attribute VB_Name = "modAnalyse"
'##### Analyse Modul ######

Option Explicit

'Komplexe Zahl
Type Complex
    Re As Double
    Im As Double
End Type

'Variablentypen
Type ZellInfoB       'Ergebnissinformation, R(2) wird whrend des Parsens berechnet, der Rest erst bei der Auswertung
    
    '*******************
    '* 0 = Instanz     *
    '* 1 = Verzweigung *
    '* 2 = Zelle       *
    '*******************
    
    I(0 To 2) As Complex    'Stromstrke
    R(0 To 2) As Complex    'Widerstand
    
    I_old(1 To 2) As Double     'Stromstrke vor dem Durchbrennen
    R_old(1 To 2) As Double     'Widerstand vor dem Durchbrennen
    
    Connected As Byte       'Fr Kondensator im Gleichstromkreis: Geladen oder nicht
    
End Type

Type ZellInfoC  'Zwischenergebnisse fr die Simulation
    State As Byte       'Status: 0 = normal
                        '1 = leuchtend
                        '2 = durchgebrannt (anzeigen)
                        '3 = durchgebrannt (berechnen)
                        '4 = sperrende Diode
                        '10 = Ersatzwiderstand
    ew_VerZw1 As Byte   'Nur bei Ersatzwiederstnden: VerZw1-Nummer, durch welche die EWS geordnet sind
    ew_gegZ As Integer  'Nur bei Ersatzwiederstnden: gegenberliegende Zelle
    ewd_R As Byte       'Bei Ersatzwiederstnden: gegenberliegende Richtung
                        'Bei Dioden: Ob der Strom in Parserrichtung flieen kann
    GaugeNr As Integer  'Index eines eventuellen analogen Anzeigegerts
End Type

Type EWSInfo    'Weitere Informationen fr Ersatzwiederstnde
    WS1 As Complex       'Der Widerstand der ersten Verzweigung
    WS2 As Complex       'Der Widerstand der zweiten Verzweigung
    gesWS As Complex     'Der resultierende Widerstand (1/Rges=... Formel)
    gesI As Complex      'Die Stromstrke, wird erst bei der Auswertung zugewiesen
    Startzelle As Integer 'Zelle an dem der Parser begonnen hat (wichtig fr Polaritt)
    ParserR As Byte      'Bei bereinstimmung der Parserrichtung der darberliegenden Instanz: 0 (!)
    OpenVerZw As Byte    '0 = beide offen       )
                         '1/2 = Verzw1/2 offen  > fr Wechselschalter
                         '3 = beide geschl.     )
End Type

Type VerZwInfo  'Warteschleife (!) zur Abarbeitung der Verzweigungen
    VerZw1 As Byte       'VerZw1-Nummer, durch welche die EWS geordnet sind
    VerZwNr As Byte      'Verzweigung 1 oder 2
End Type

'Interne Variablen
Dim n As Integer, m As Integer           'Variablen fr For... Next Schleifen
Dim EWS(1 To 128) As EWSInfo             'Informationen ber Verzweigungen (geordnet nach der VerZw1 Nr.)
Dim Stromquelle As Integer               'Zellennr. der Stromquelle
Dim EWperRound As Integer                'Pro Durchlauf eliminierte Ersatzwiderstnde
Dim Zellen(1 To 128) As New Collection   'Speichert alle Zellen einer Verzw. mit Zellennr. / Ws. (geordnet nach Verzwnr.)
Dim Richtung As Byte                     'Primrrichtung
Dim lRichtung As Byte                    'Letzte Richtung
Dim aZ As Integer                        'Aktuell bearbeitete Zelle
Dim R(1 To 3) As Byte                    'Startrichtungen beim Pre-Parsing
Dim Z(1 To 3) As Integer                 'Zielzellen beim Pre-Parsing
Dim SR As Byte                           'Stromlaufrichtung
Dim aktVerZw As Integer                  'Nummer der aktuellen Verzweigung
Dim VerZw(1 To 128) As VerZwInfo         '"Warteschleife" fr die Ersatzwiderstnde bei der Auswertung
Dim wrVerZw As Byte, rdVerZw As Byte     'Warteschleifennummer schreiben / lesen
Dim VerZwOpen As Byte                    'Zwischenspeicherung fr Wechselschalter
Dim lZ As Integer                        'Letzte Zelle
Dim aktWS As Complex                     'Aktueller Widerstand (in NchsterKP)
Dim lWS As Complex                       'letzter gefundener Widerstand (zur Berechnung des Gesammtws.)
Dim WS As Complex                        'Widerstand der aktuellen Zelle (NchsterKP)
Dim gesWS As Complex                     'Gesamtwiderstand eines Ersatzwiderstandes
Dim BzWS As Single                       'Zellenwiderstand eines Bauelements
Dim KnoPu(1 To 128) As Integer           'Array fr die Abbarbeitung der Knotenpunkte
Dim KnoPuS(1 To 64) As Integer           'Knotenpunkte sortiert
Dim wrKnoPuS As Byte                     'Zhler fr das sortieren der KPs
Dim cKnoPu As Byte, gKnoPu As Byte       'Aktuelle Nr. im KnoPu Array; Anzahl der Eintrge im KnoPu Array
Dim aktKP As Integer                     'Aktueller Knotenpunkt der untersucht wird (Zellennr.)
Dim aktI As Complex                      'Aktuelle Stromstrke beim Auswerten ( I = U / R )
Dim instI As Complex                     'Stromstrke der Instanz
Dim Spannung As Complex                  'Aktuelle Spannung der bearbeiteten Verzweigung
Dim ErrorCode As Byte                    'Fehlernr. fr die Parsing Errors in NchsterKP
Dim Restart As Byte                      '1: sperrende Dioden
                                         '2: Durchgebrannte Glhbirnen
                                         '3: letzter Durchlauf wegen durchgebrannten Glhbirnen
Dim Diods As Byte                        'Eventuell sperrende Dioden
Dim RestartC As Byte                     'Neustart wegen Laden von Kondensator

'ffentliche Variablen
Public Omega As Double                   '2 * Pi * Frequenz (braucht auch das Phasendiagramm)
Public EZS As Byte                       'Echtzeitsimulation
Public SubError As Boolean               'Gibt zurck ob in NchsterKP ein Fehler auftrat
Public bZelle() As ZellInfoB             'Simulationsergebnisse (geordnet nach Zellennr.)
Public cZelle() As ZellInfoC             'Simulationszwischenergebnisse (geordnet nach Zellennr.)
Public s_L As Double, s_C As Double      'L und C fr Schwingkreise
Public s_R As Double                     'R fr Schwingkreise

'Zentrale Sub zur Simulation
'Quiet=1 bedeutet keine Fehlermeldungen, etc.
'NoUpdate=1, bedeutet keine Aktualisierungen der Datenausgabe
Public Sub Analyse(Optional Quiet As Byte, Optional NoUpdate As Byte)
Dim CountLoops As Integer
Dim Capacities As Integer
'### Vorbereitungsphase ###
Restart = 0
RestartC = 0
Diods = 0
ClearAll 1, 1                  'Ergebnisse der letzten Simulation lschen
If b_BzWS = 1 Then BzWS = zWS
SubError = False
R:                                      'Sprungmarke fr Simulationsneustart (durchgebrannten Bauelementen, Kondensatoren laden,...)
For n = 1 To 128                        'Variablen zurcksetzten...
    ClearCol Zellen(n)
Next
EWperRound = 0
aktVerZw = 1
cKnoPu = 0
Capacities = 0
If EZS <> 1 And Restart = 0 Then        'Einstellungen nur bei einmaliger Analyse / erstem Durchlauf
    wrKnoPuS = 0
    Stromquelle = 0
    gKnoPu = 0
    For n = 1 To 64                     'Variablen zurcksetzten...
        KnoPuS(n) = 0
    Next
    For n = 1 To hZellen * vZellen
        If SimIDtoCat(aZelle(n).ID) = 1 Then       'Nach Stromquelle suchen
            If Stromquelle > 0 Then GoTo a
            Stromquelle = n
        ElseIf SimIDtoCat(aZelle(n).ID) = 4 Then   'Nummerierung Knotenpunkte
            gKnoPu = gKnoPu + 1
            KnoPu(gKnoPu) = n
        End If
        If aZelle(n).ID = 16 Then Capacities = Capacities + 1
        cZelle(n).State = 0
    Next
ElseIf Restart > 0 Then
    For n = 1 To hZellen * vZellen
        If cZelle(n).State = 10 Then cZelle(n).State = 0
    Next
Else
    For n = 1 To hZellen * vZellen
        cZelle(n).State = 0
    Next
End If
If Stromquelle = 0 Then GoTo a      'Auf vorhandene Stromquelle berprfen
If aZelle(Stromquelle).ID = 10 Then 'Auf Wechselstromquelle prfen
    Omega = 2 * Pi * SngToDbl(aZelle(Stromquelle).Param2)
Else
    If Capacities > 0 Then
        If RestartC = 0 And (EZS = 1 Or EZS = 2) Then 'RestartC anmelden
            RestartC = 1
            Omega = 0
        ElseIf RestartC = 2 Then                      'Durchfhren
            Omega = 1
        Else
            Omega = 0
        End If
    Else
        Omega = 0
    End If
End If
'### Ersatzwiderstnde eliminieren ###
If gKnoPu > 0 Then
    Do
        '### Anfang Zhler ###
        If EZS <> 1 And Restart = 0 Then
            '### Durchprobiermethode ###
            If cKnoPu < gKnoPu Then   'Zhler Knotenpunkte
                cKnoPu = cKnoPu + 1
            Else                      'Neustart
                cKnoPu = 1
                If EWperRound = 0 Then GoTo b 'Simulation verlassen, wenn im letzten Durchlauf kein EW eliminiert wurde
                EWperRound = 0
            End If
            For n = cKnoPu To gKnoPu
                If KnoPu(n) > 0 Then          'berprfen ob dieser KP nicht eliminiert ist
                    cKnoPu = n
                    aktKP = KnoPu(cKnoPu)     'Diesen KP auswhlen
                    Exit For
                ElseIf n = gKnoPu Then        'Kein freien KP gefunden
                    For m = 1 To gKnoPu       'Neustart => von Anfang an auf freie KP berprfen
                        If KnoPu(m) > 0 Then
                            If EWperRound = 0 Then GoTo b 'Simulation verlassen, wenn im letzten Durchlauf kein EW eliminiert wurde
                            EWperRound = 0
                            cKnoPu = m
                            aktKP = KnoPu(cKnoPu)  'Diesen KP auswhlen
                            Exit For
                        ElseIf m = gKnoPu Then
                            Exit Do                'Alle KP sind eliminiert. Do-Schleife verlassen
                        End If
                    Next
                End If
            Next
        Else
            '### Knotenpunkte bereits bekannt ###
            If cKnoPu = wrKnoPuS Then Exit Do 'Fertig
            cKnoPu = cKnoPu + 1
            aktKP = KnoPuS(cKnoPu)
        End If
        '### Ende Zhler ###
        
        '### Anfang Parsing | Pre-Parsing ###
        m = 0
        For n = 0 To 3
            If GetZellZone(aktKP, n) = True Then 'berprfen ob der Knotenpunkt diese Ader besitzt
                m = m + 1
                R(m) = n
                Richtung = n
                aZ = aktKP
                ParseKP Quiet
                If SubError = True Then Exit Sub 'ParseKP bernimmt Fehlerbehandlung
                Z(m) = aZ
            End If
        Next
        'berprfen ob ein gemeinsamer KP gefunden wurde
        If Z(1) = Z(2) Then      'Gemeinsamer KP, Richtungen passen bereits
        ElseIf Z(1) = Z(3) Then  ' " " , aber Richtungen auf r(1;2) reduzieren
            R(2) = R(3)
        ElseIf Z(2) = Z(3) Then  ' " " " " " " "
            R(1) = R(2)
            R(2) = R(3)
        Else                     'Kein gemeinsamer KP
            GoTo EndeLoop
        End If
        '### Ende Pre-Parsing ### Beginn Parsing + Berechnen ###
        aZ = aktKP
        lZ = aZ
        'Verzweigung 1
        Richtung = R(1)
        NchsterKP
        lWS = aktWS
        lRichtung = Richtung
        aktVerZw = aktVerZw + 1
        'Verzweigung 2
        aZ = aktKP
        Richtung = R(2)
        NchsterKP
        'Heraufinden welche Richtungen tatschlich weiterfhren (Wechselschalter!)
        VerZwOpen = 0
        If aZelle(lZ).ID = 19 Then
            If CheckSwitchR(lZ, R(1)) = True Then 'Diese Richtung offen
                VerZwOpen = 1
            Else 'andere Richtung offen
                VerZwOpen = 2
            End If
        End If
        If aZelle(aZ).ID = 19 Then
            If CheckSwitchR(aZ, TurnD(lRichtung)) = True Then 'Diese Richtung offen
                If VerZwOpen = 2 Then
                    VerZwOpen = 3
                Else
                    VerZwOpen = 1
                End If
            Else 'andere Richtung offen
                If VerZwOpen = 1 Then
                    VerZwOpen = 3
                Else 'andere Richtung offen
                    VerZwOpen = 2
                End If
            End If
        End If
        If VerZwOpen = 1 Then
            aktWS.Re = -1
        ElseIf VerZwOpen = 2 Then
            lWS.Re = -1
        ElseIf VerZwOpen = 3 Then
            lWS.Re = -1
            aktWS.Re = -1
        End If
        'Ersatzwiderstand eliminieren
        If lWS.Re = -1 And aktWS.Re = -1 Then
            gesWS.Re = -1
        ElseIf lWS.Re = -1 Then
            gesWS = aktWS
        ElseIf aktWS.Re = -1 Then
            gesWS = lWS
        ElseIf aktWS.Re = 0 And aktWS.Im = 0 And lWS.Re = 0 And lWS.Im = 0 Then 'Division durch 0 vermeiden
            gesWS = ComplexNull
        Else
            gesWS = DivideC(MultiplyC(aktWS, lWS), AddC(aktWS, lWS))
        End If
        'Ersatzwiderstand eliminieren und Informationen zum berspringen hinzufgen
        cZelle(lZ).State = 10: cZelle(aZ).State = 10
        cZelle(lZ).ew_VerZw1 = aktVerZw: cZelle(aZ).ew_VerZw1 = aktVerZw
        cZelle(lZ).ew_gegZ = aZ: cZelle(aZ).ew_gegZ = lZ
        cZelle(lZ).ewd_R = Get3rdR(aZ, TurnD(lRichtung), TurnD(Richtung)): cZelle(aZ).ewd_R = Get3rdR(lZ, R(1), R(2))
        EWS(aktVerZw).WS1 = aktWS
        EWS(aktVerZw).WS2 = lWS
        EWS(aktVerZw).gesWS = gesWS
        EWS(aktVerZw).Startzelle = lZ
        If EZS <> 1 And Restart = 0 Then
            wrKnoPuS = wrKnoPuS + 1 'Sortieren der Knotenpunkte
            KnoPuS(wrKnoPuS) = aZ
            For m = 1 To gKnoPu  'Im KnoPu Array die beiden eliminierten KPs lschen
                If KnoPu(m) = aZ Or KnoPu(m) = lZ Then KnoPu(m) = 0
            Next
        End If
        aktVerZw = aktVerZw + 1
        EWperRound = EWperRound + 1
        '### Ende Parsing + Berechnen ###
EndeLoop:
        CountLoops = CountLoops + 1 'Zhler
    Loop
End If
'### Letzter NchsterKP Durchlauf ###
aZ = Stromquelle                 'Zeiger an Stromquelle setzen
If aZelle(aZ).AusR = 0 Then      'Richtung festlegen
    Richtung = 0
ElseIf aZelle(aZ).AusR = 1 Then
    Richtung = 3
ElseIf aZelle(aZ).AusR = 2 Then
    Richtung = 1
ElseIf aZelle(aZ).AusR = 3 Then
    Richtung = 2
End If
ParseKP Quiet                          'Letzter Durchlauf
If SubError = True Then Exit Sub
NchsterKP
'### Gesamtzustand ermitteln ###
With frmHaupt
    If AbsC(aktWS) = 0 And Diods = 0 Then
        .lblRes.ForeColor = vbRed
        .lblRes.Caption = "Kurzschluss"
        ClearAll , 1
        GoTo Z
    ElseIf aktWS.Re = -1 Then
        If Restart = 3 Then
            .lblRes.ForeColor = vbRed
            .lblRes.Caption = "Durchgebrannt"
        Else
            ClearAll , 1
            .lblRes.ForeColor = vbBlack
            .lblRes.Caption = "Kein Stromfluss"
        End If
    ElseIf Restart = 3 Then
        .lblRes.ForeColor = &H80FF&
        .lblRes.Caption = "Partiell durchgebrannt"
    Else
        .lblRes.ForeColor = &H8F00&
        .lblRes.Caption = "Keine Probleme"
    End If
End With
'### Zuordnen der Spannungen ###
wrVerZw = 0
rdVerZw = 1
'Erste Instanz berechnen
Spannung.Re = SngToDbl(aZelle(Stromquelle).Param1)
Spannung.Im = 0
gesWS = aktWS
If AbsC(aktWS) > 0 Then
    instI = DivideC(Spannung, aktWS)
Else
    instI = ComplexNull
End If
SR = 0   'Stromlaufrichtung setzten
Do 'Schleife die jeweils die Verzweigungen durchgeht
    If AbsC(aktWS) = 0 Then              'Widerstand 0 ==> Stromstrke der nchsthheren Instanz bernehmen
        aktI = instI
    ElseIf aktWS.Re < 0 Then              'Widerstand unendlich ==> Stromstrke 0
        aktI = ComplexNull
    Else
        aktI = DivideC(Spannung, aktWS)  'Spannung pro Widerstand berechnen
    End If
    m = Zellen(aktVerZw).Count
    'berprfen auf sperrende Dioden
    If Diods = 1 Then
        For n = 1 To Zellen(aktVerZw).Count 'Schleife, die die einzelnen Zellen der Verzweigungen durchgeht
            aZ = CInt(Mid(Zellen(aktVerZw).Item(n), 2, 4))
            If aZelle(aZ).ID = 13 Or aZelle(aZ).ID = 14 Then
                If -cZelle(aZ).ewd_R Xor -SR Then 'Sperrt
                    Restart = 1
                    cZelle(aZ).State = 4
                End If
            End If
        Next
    End If
    For n = 1 To Zellen(aktVerZw).Count 'Schleife, die die einzelnen Zellen der Verzweigungen durchgeht
        aZ = CInt(Mid(Zellen(aktVerZw).Item(n), 2, 4)) 'Zellennr. einlesen
        'Nur berechnen wenn es keine Dioden gibt (bei Dioden wird neugestartet, d.h. neu berechnet)
        If Left(Zellen(aktVerZw).Item(n), 1) = "Z" And Diods <> 1 Then 'Normale Zelle
            'Alte Werte bei Durchgebranntem
            If cZelle(aZ).State = 3 Then
                bZelle(aZ).I_old(2) = AbsC(bZelle(aZ).I(2))
                bZelle(aZ).R_old(1) = AbsC(bZelle(aZ).R(1))
                bZelle(aZ).I_old(1) = AbsC(bZelle(aZ).I(1))
            End If
            'Instanz
            bZelle(aZ).R(0) = gesWS
            bZelle(aZ).I(0) = instI
            'Verzweigung
            bZelle(aZ).R(1) = aktWS
            bZelle(aZ).I(1) = aktI
            'Zelle
            bZelle(aZ).I(2) = aktI
            'Glhbirnen/LEDs leuchtend/durchgebrannt darstellen
            If (aZelle(aZ).ID = 4 Or aZelle(aZ).ID = 14) And cZelle(aZ).State = 0 And RestartC <> 2 Then
                If GbDb = 1 And GetValDbl(aZ, vbZelle, vbSpannung, vbSchein) >= (aZelle(aZ).Param1 * (GbDbPro / 100)) Then
                    If DbBr = 1 Then
                        cZelle(aZ).State = 3
                        Restart = 2
                    Else
                        cZelle(aZ).State = 2
                    End If
                ElseIf GbLe = 1 And GetValDbl(aZ, vbZelle, vbSpannung, vbSchein) >= (aZelle(aZ).Param1 * (GbLePro / 100)) Then
                    cZelle(aZ).State = 1
                End If
                frmHaupt.PaintImage aZ
            End If
            'Widerstnde durchgebrannt darstellen
            If aZelle(aZ).ID = 12 And cZelle(aZ).State = 0 And bZelle(aZ).R(2).Re > 0 And RestartC <> 2 Then
                If WsDb = 1 And GetValDbl(aZ, vbZelle, vbLeistung, vbSchein) >= (aZelle(aZ).Param2 * (WsDbPro / 100)) Then
                    If DbBr = 1 Then
                        cZelle(aZ).State = 3
                        Restart = 2
                    Else
                        cZelle(aZ).State = 2
                    End If
                End If
                frmHaupt.PaintImage aZ
            End If
        ElseIf Left(Zellen(aktVerZw).Item(n), 1) = "V" Then 'Knotenpunkt
            'Verzweigungen in Warteschleife setzen
            wrVerZw = wrVerZw + 1
            VerZw(wrVerZw).VerZw1 = cZelle(aZ).ew_VerZw1
            VerZw(wrVerZw).VerZwNr = 1
            EWS(VerZw(wrVerZw).VerZw1).gesI = aktI
            'Stromrichtung bestimmen
            EWS(VerZw(wrVerZw).VerZw1).ParserR = -((Not (EWS(VerZw(wrVerZw).VerZw1).Startzelle = aZ)) Xor (-SR))
        End If
    Next
    
    'Nchsten Ersatzwiderstand in Warteschleife suchen
    If VerZw(rdVerZw).VerZw1 > 0 Then
        instI = EWS(VerZw(rdVerZw).VerZw1).gesI
        gesWS = EWS(VerZw(rdVerZw).VerZw1).gesWS
        Spannung = MultiplyC(instI, gesWS)
        SR = EWS(VerZw(rdVerZw).VerZw1).ParserR
        If VerZw(rdVerZw).VerZwNr = 1 Then        'Erste Verzweigung
            aktVerZw = VerZw(rdVerZw).VerZw1
            aktWS = EWS(VerZw(rdVerZw).VerZw1).WS1
            VerZw(rdVerZw).VerZwNr = 2
        ElseIf VerZw(rdVerZw).VerZwNr = 2 Then    'Zweite Verzweigung
            aktVerZw = VerZw(rdVerZw).VerZw1 - 1
            aktWS = EWS(VerZw(rdVerZw).VerZw1).WS2
            VerZw(rdVerZw).VerZw1 = 0
            rdVerZw = rdVerZw + 1
        End If
    Else
        Exit Do 'Fertig
    End If
Loop
'berprfen auf Neustart (1)
If RestartC < 2 Then
    If Diods = 1 Then
        If Restart = 1 Then  'Dioden sperren
            Diods = 2
        Else
            Diods = 0        'Dioden sperren nicht
            Restart = 1
        End If
        GoTo R
    ElseIf Restart = 2 Then  'Glhbirnen durchgebrannt
        Restart = 3
        GoTo R
    End If
End If
'berprfen auf Neustart (2)
If RestartC = 1 Then
    Restart = 0
    RestartC = 2
    GoTo R
ElseIf RestartC = 2 Then
    'Kondensatoren brprfen
    For n = 1 To hZellen * vZellen
        If aZelle(n).ID = 16 Then
            If AbsC(bZelle(n).I(1)) > 0 Then
                bZelle(n).Connected = True
            End If
        End If
    Next
    Restart = 0
    GoTo R
End If
Z:
If SimWin = 1 And NoUpdate = 0 Then                'Simulationsfenster aktualisieren
    frmHaupt.UpdateSimWin
    frmSimWin.UpdateData
End If
If PhDiaAct = 1 Then frmPhasendiagramm.Update      'Phasendiagramm aktualisieren
If MessWin = 1 And NoUpdate = 0 Then frmHaupt.UpdateMessWin   'Messfenster aktualisieren
If NoUpdate = 0 And EZS = 1 Then  'Messgerte aktualisieren
    For n = 1 To frmHaupt.c_Gauge
        frmHaupt.cGauge(n).Update
    Next
End If

If Command = "-count" Then frmHaupt.lblCount.Caption = CountLoops + 1
If returnMessage = 0 And EZS = 0 And Quiet = 0 Then
    If SimWin = 1 Then
        MsgBox "Analyse erfolgreich.", vbInformation
    Else
        If MsgBox("Analyse erfolgreich. Soll das Simulationsfenster geffnet werden?", vbYesNo + vbInformation) = vbYes Then frmSimWin.Show , frmHaupt
    End If
End If
Exit Sub
'Fehlermeldungen:
a:
    If returnMessage = 0 And EZS = 0 And Quiet = 0 Then MsgBox "Mehr oder weniger als eine Stromquelle ist nicht zulssig!", , "Fehler"
    GoTo C
b:
    If returnMessage = 0 And EZS = 0 And Quiet = 0 Then
        If MsgBox("Fehler beim Analysieren des Schaltbildes. Wollen Sie den Fehlerbericht sehen?", vbYesNo + vbQuestion, "Fehler") = vbYes Then
            frmErrWin.Text1.Text = "Fehler 7: Das Schaltbild enthlt korrespondierende Verzweigungen. " & vbCrLf & vbCrLf & "Folgende Knotenpunkte wiesen keinen in sich abgeschlossenen Ersatzwiderstand auf: " & vbCrLf
            For n = 1 To gKnoPu
                If KnoPu(n) > 0 Then frmErrWin.Text1.Text = frmErrWin.Text1.Text & "Nr. " & KnoPu(n) & vbCrLf
            Next
            frmErrWin.Show vbModal, frmHaupt
        End If
    End If
C:
    SubError = True
    ClearAll 1, 1
End Sub

'Zur Berechnung eines bestimmten Bereichs
Public Function ParseArea(ByVal Startzelle As Integer, ByVal StartRichtung As Byte, ByVal Endzelle As Integer) As Complex
aZ = Startzelle
Richtung = StartRichtung
NchsterKP Endzelle, , 1
ParseArea = aktWS
End Function

'Schwingkreis parsen (Rckgabe -> 0: nichts gefunden, 1: Alles ok, 2: Fehler
Public Function ParseRC(ByVal Zelle As Integer, ByVal Area As Byte) As Byte
m = 0
For n = 0 To 3
    If GetZellZone(Zelle, n) = True Then
        m = m + 1
        R(m) = n
    End If
Next
If m <> 2 Then Exit Function 'Bauelement mit zwei Anschlssen erforderlich
SubError = False
If Area = 0 Then 'Instanz
    aZ = Zelle
    Richtung = R(1)
    NchsterKP , 1
    Z(1) = aZ
    R(1) = TurnD(Richtung) 'Abgehende Richtung 1
    If SubError = True Then Exit Function
    Richtung = R(2)
    aZ = Zelle
    NchsterKP , 1
    Z(2) = aZ   'Start/Zielknotenpunkte Z(1) und Z(2)
    If SubError = True Then Exit Function
    m = 1
    For n = 0 To 3        'Andere mgliche abgehende Richtungen
        If GetZellZone(Z(1), n) = True And n <> R(1) Then
            m = m + 1
            R(m) = n
        End If
    Next
    'Erster Versuch Zweig II
    s_L = 0
    s_C = 0
    s_R = 0
    aZ = Z(1)
    Richtung = R(2)
    NchsterKP , 2
    If SubError = True Then Exit Function
    'Zweiter Versuch Zweig II
    s_L = 0
    s_C = 0
    s_R = 0
    If Not aZ = Z(2) Then
        aZ = Z(1)
        Richtung = R(3)
        NchsterKP , 2
        If SubError = True Then Exit Function
    End If
    'Zweig I
    aZ = Z(1)
    Richtung = R(1)
    NchsterKP , 2
    If aZ = Z(2) Then 'Alles ok
        ParseRC = 1
    End If
Else  'Zweig
    s_L = 0
    s_C = 0
    s_R = 0
    aZ = Zelle
    Richtung = R(1)
    NchsterKP , 2
    If SubError = True Then Exit Function
    Richtung = R(2)
    aZ = Zelle
    NchsterKP , 2, 1
    If SubError = True Then Exit Function
    ParseRC = 1
End If
End Function

'Sub um den nchsten Knotenpunkt zu finden (keine Fehlerbehandlung mehr, da dies FindEndKP bernimmt)
'keepcell = 1 -> erste zelle mit berechnen
'RC = 1 -> Knotenpunkt finden (unabhngig von Ersatzwiderstand)
'   = 2 -> Ersatzwiderstnde unzulssig
Private Sub NchsterKP(Optional Endzelle As Integer, Optional ByRef RC As Byte, Optional ByVal KeepCell As Byte)
'//// Widerstandswerte: Stcker Physik S. 488ff
Dim Fertig As Boolean      'Gibt an, ob die Do Schleife verlassen werden soll
aktWS = ComplexNull
Do
    If KeepCell = 0 Then
        aZ = NchsteZelle(aZ, Richtung)
    Else
        KeepCell = 0
    End If
    Select Case aZelle(aZ).ID   'Unterscheidung Bauelemente
        Case 1 'Stromquelle
            If Endzelle = 0 Then Fertig = True
            WS.Re = SngToDbl(aZelle(aZ).Param2)
        Case 10    'Wechselstromquelle
            Fertig = True
        Case 2, 3, 6, 11 'Amperemeter, Voltmeter und Widerstand (normal und Poti)
            WS.Re = SngToDbl(aZelle(aZ).Param1)
            n = n
        Case 4 'Glhbirne
            If cZelle(aZ).State = 3 Then  'Durchgebrannt
                WS.Re = -1
            Else
                If aZelle(aZ).Param2 > 0 Then WS.Re = (SngToDbl(aZelle(aZ).Param1) ^ 2) / SngToDbl(aZelle(aZ).Param2)
            End If
        Case 5 'Schalter
            If aZelle(aZ).Param1 = 0 Then WS.Re = -1
        Case 7 'Verbraucher (V, W)
            If aZelle(aZ).Param2 > 0 Then WS.Re = (SngToDbl(aZelle(aZ).Param1) ^ 2) / SngToDbl(aZelle(aZ).Param2)
        Case 8 'Verbraucher (V, A)
            If aZelle(aZ).Param2 > 0 Then WS.Re = SngToDbl(aZelle(aZ).Param1) / SngToDbl(aZelle(aZ).Param2)
        Case 9 'Verbraucher (W, A)
            If aZelle(aZ).Param2 > 0 Then WS.Re = SngToDbl(aZelle(aZ).Param1) / (SngToDbl(aZelle(aZ).Param2) ^ 2)
        Case 12 'Maximallastwiderstand
            If cZelle(aZ).State = 3 Then  'Durchgebrannt
                WS.Re = -1
            Else
                WS.Re = aZelle(aZ).Param1
            End If
        Case 13, 14 'Diode
            If Restart = 0 Then Diods = 1 'Sperrt eventuell
            If cZelle(aZ).State = 3 Or cZelle(aZ).State = 4 Then 'Sperrt oder durchgebrannt
                WS.Re = -1
            Else 'Normal berechnen
                If aZelle(aZ).Param2 > 0 And aZelle(aZ).ID = 14 Then WS.Re = SngToDbl(aZelle(aZ).Param1) / SngToDbl(aZelle(aZ).Param2)
                'Bestimmung der Stromflussrichtung
                If (Richtung = 0 And aZelle(aZ).AusR = 2) Or (Richtung = 1 And aZelle(aZ).AusR = 0) Or (Richtung = 2 And aZelle(aZ).AusR = 1) Or (Richtung = 3 And aZelle(aZ).AusR = 3) Then
                    cZelle(aZ).ewd_R = 0
                Else
                    cZelle(aZ).ewd_R = 1
                End If
            End If
        Case 16 'Kondensator
            If (aZelle(aZ).Param1 * Omega) > 0 Then
                WS.Im = -1 / (SngToDbl(aZelle(aZ).Param1) * Omega)
                If RC = 2 Then
                    If s_C > 0 Then
                        s_C = s_C * aZelle(aZ).Param1 / (aZelle(aZ).Param1 + s_C)
                    Else
                        s_C = aZelle(aZ).Param1
                    End If
                End If
            Else
                WS.Re = -1
            End If
        Case 17 'Spule
            WS.Re = SngToDbl(aZelle(aZ).Param1)
            WS.Im = SngToDbl(aZelle(aZ).Param2) * Omega
            If RC = 2 Then s_L = s_L + aZelle(aZ).Param2
        Case 18 'Induktivitt
            WS.Re = 0
            WS.Im = SngToDbl(aZelle(aZ).Param1) * Omega
            If RC = 2 Then s_L = s_L + aZelle(aZ).Param1
        Case 22 To 25 'Eckpunkt
            If GetDirByID(aZelle(aZ).ID, 1) = TurnD(Richtung) Then
                Richtung = GetDirByID(aZelle(aZ).ID, 2)
            ElseIf GetDirByID(aZelle(aZ).ID, 2) = TurnD(Richtung) Then
                Richtung = GetDirByID(aZelle(aZ).ID, 1)
            End If
        Case 26 To 29, 19 'Knotenpunkt gefunden
            If cZelle(aZ).State = 0 Or RC > 0 Then
                Fertig = True
            Else      'Ersatzwiderstand
                Zellen(aktVerZw).Add ("V" & aZ)
                Richtung = cZelle(aZ).ewd_R
                WS = EWS(cZelle(aZ).ew_VerZw1).gesWS
                If WS.Re = -1 Then
                    aktWS.Re = -1
                Else
                    If aktWS.Re > -1 Then
                        aktWS = AddC(aktWS, WS)
                    End If
                End If
                aZ = cZelle(aZ).ew_gegZ
            End If
    End Select
    If cZelle(aZ).State < 10 And Not SimIDtoCat(aZelle(aZ).ID) = 4 Then
        'Zellenwiderstand hinzufgen
        If SimIDtoCat(aZelle(aZ).ID) = 3 Then 'Verbindung
            If aktWS.Re > -1 And WS.Re > -1 Then WS.Re = WS.Re + zWS
        Else                                  'Bauelement
            If aktWS.Re > -1 And WS.Re > -1 Then WS.Re = WS.Re + BzWS
        End If
        'Widerstand in die Zellen-Variable eintragen
        If WS.Re = -1 Then
            aktWS.Re = -1
        Else
            If aktWS.Re > -1 Then
                aktWS = AddC(aktWS, WS)
            End If
        End If
        If Endzelle = 0 And RC = 0 Then Zellen(aktVerZw).Add ("Z" & aZ)
    End If
    If cZelle(aZ).State < 10 And Endzelle = 0 And RC = 0 Then
        'Alter Widerstand fr durchgebrannte Bauelemente
        If WS.Re = -1 And bZelle(aZ).R(2).Re > 0 Then
            bZelle(aZ).R_old(2) = bZelle(aZ).R(2).Re
        End If
        'Widerstand eintragen
        bZelle(aZ).R(2) = WS
    End If
    If RC = 2 Then s_R = s_R + WS.Re
    WS = ComplexNull
Loop Until Fertig = True Or aZ = Endzelle
End Sub

'Sub zur Voraberkennung von Ersatzwiderstnden und Fehlerbehandlung (Pre-Parsing)
Private Sub ParseKP(Optional Quiet As Byte)
Dim Fertig As Boolean                       'Gibt an, ob die Do Schleife verlassen werden soll
Do
    '### Fehlerbehandlung
    If NchsteZelle(aZ, Richtung) = 0 Then  'berprfen ob die nchste Richtung existiert
        ErrorCode = 2
        GoTo b
    End If
    aZ = NchsteZelle(aZ, Richtung)
    If aZelle(aZ).ID = 0 Or aZelle(aZ).ID = 15 Then 'leer
        ErrorCode = 1
        GoTo b
    End If
    If GetZellZone(aZ, TurnD(Richtung)) = False Then
        ErrorCode = 3
        GoTo b
    End If
    Select Case aZelle(aZ).ID   'Unterscheidung Bauelemente
        Case 1, 10 'Stromquelle
            Fertig = True
        Case 13, 14
            If Omega > 0 Then 'Keine Dioden bei Wechselstrom
                ErrorCode = 6
                GoTo b
            End If
        Case 22 To 25 'Eckpunkt
            If GetDirByID(aZelle(aZ).ID, 1) = TurnD(Richtung) Then
                Richtung = GetDirByID(aZelle(aZ).ID, 2)
            ElseIf GetDirByID(aZelle(aZ).ID, 2) = TurnD(Richtung) Then
                Richtung = GetDirByID(aZelle(aZ).ID, 1)
            Else
                ErrorCode = 4
                GoTo b
            End If
        Case 26 To 29, 19 'Knotenpunkt gefunden
            If cZelle(aZ).State = 0 Then
                Fertig = True
            Else          'Ersatzwiderstand
                If (Richtung = TurnD(cZelle(cZelle(aZ).ew_gegZ).ewd_R)) = False Then
                    ErrorCode = 5
                    GoTo b
                End If
                Richtung = cZelle(aZ).ewd_R
                aZ = cZelle(aZ).ew_gegZ
            End If
    End Select
Loop Until Fertig = True
Exit Sub
'Fehlermeldungen:
b:
    If returnMessage = 0 And EZS = 0 And Quiet = 0 Then
        If MsgBox("Fehler beim Parsen der Stromkreisadern. Wollen Sie den Fehlerbericht sehen?", vbYesNo + vbQuestion, "Fehler") = vbYes Then
            Select Case ErrorCode
                Case 1
                    frmErrWin.Text1.Text = "Fehler 1: Es existiert kein nachfolgendes Bauelement."
                Case 2
                    frmErrWin.Text1.Text = "Fehler 2: Die Stromkreisader fhrt gegen den Rand."
                Case 3
                    frmErrWin.Text1.Text = "Fehler 3: Das nachfolgende Bauelement ist falsch ausgerichtet."
                Case 4
                    frmErrWin.Text1.Text = "Fehler 4: Ein Eckpunkt ist falsch ausgerichtet."
                Case 5
                    frmErrWin.Text1.Text = "Fehler 5: Ein Knotenpunkt wurde falsch kontaktiert."
                Case 6
                    frmErrWin.Text1.Text = "Fehler 6: Dioden sind in einem Schaltkreis mit Wechselspannung nicht erlaubt."
            End Select
            frmErrWin.Text1 = frmErrWin.Text1 & vbCrLf & vbCrLf & "Weitere Informationen: " & vbCrLf
            frmErrWin.Text1 = frmErrWin.Text1 & "Zelle: " & CellXYstr(aZ) & vbCrLf
            Dim strRichtung As String
            Select Case Richtung
                Case 0
                    strRichtung = "Links"
                Case 1
                    strRichtung = "Rechts"
                Case 2
                    strRichtung = "Oben"
                Case 3
                    strRichtung = "Unten"
            End Select
            frmErrWin.Text1 = frmErrWin.Text1 & "Richtung: " & strRichtung & vbCrLf
            frmErrWin.Text1 = frmErrWin.Text1 & "Bauelement: " & IDtoInhalt(aZelle(aZ).ID) & vbCrLf
            frmErrWin.Show vbModal, frmHaupt
        End If
    End If
    SubError = True
End Sub

'Simulationsergebnisse wieder lschen
Public Sub ClearAll(Optional ClearR2 As Byte, Optional ClearGraphics As Byte)
For n = 1 To vZellen * hZellen
    bZelle(n).I(0) = ComplexNull
    bZelle(n).I(1) = ComplexNull
    bZelle(n).I(2) = ComplexNull
    bZelle(n).I_old(2) = 0
    bZelle(n).R(0) = ComplexNull
    bZelle(n).R(1) = ComplexNull
    If ClearR2 = 1 Then bZelle(n).R(2) = ComplexNull
    bZelle(n).R_old(2) = 0
    bZelle(n).Connected = 0
    cZelle(n).State = 0
    If ClearGraphics = 1 And (aZelle(n).ID = 4 Or (aZelle(n).ID >= 12 And aZelle(n).ID <= 14)) Then frmHaupt.PaintImage (n)
Next
End Sub
