Attribute VB_Name = "modBauelemente"
'##### Zuordnungsfunktionen fr Bauteile #####

Option Explicit

Public Const cOb = 19                    'Anzahl Standardelemente
Public Const cCat = 5                    'Anzahl Kategorieren

'Weist jeder ID einen Namen zu
Function IDtoInhalt(ByVal ID As Integer) As String
Select Case ID
    Case 0
        IDtoInhalt = "Leere Zelle"
    Case 1
        IDtoInhalt = "Stromquelle"
    Case 2
        IDtoInhalt = "Voltmeter"
    Case 3
        IDtoInhalt = "Amperemeter"
    Case 4
        IDtoInhalt = "Glhbirne"
    Case 5
        IDtoInhalt = "Schalter"
    Case 6
        IDtoInhalt = "Widerstand"
    Case 7
        IDtoInhalt = "Verbraucher (V, W)"
    Case 8
        IDtoInhalt = "Verbraucher (V, A)"
    Case 9
        IDtoInhalt = "Verbraucher (W, A)"
    Case 10
        IDtoInhalt = "Wechselstromquelle"
    Case 11
        IDtoInhalt = "Potentiometer"
    Case 12
        IDtoInhalt = "Maximallastwiderstand"
    Case 13
        IDtoInhalt = "Diode"
    Case 14
        IDtoInhalt = "Leuchtdiode (LED)"
    Case 15
        IDtoInhalt = "Textzelle"
    Case 16
        IDtoInhalt = "Kondensator"
    Case 17
        IDtoInhalt = "Spule"
    Case 18
        IDtoInhalt = "Induktivitt"
    Case 19
        IDtoInhalt = "Wechselschalter"
    Case 20
        IDtoInhalt = "Verbindung horizontal"
    Case 21
        IDtoInhalt = "Verbindung vertikal"
    Case 22
        IDtoInhalt = "Eckstck (LO)"
    Case 23
        IDtoInhalt = "Eckstck (LU)"
    Case 24
        IDtoInhalt = "Eckstck (RO)"
    Case 25
        IDtoInhalt = "Eckstck (RU)"
    Case 26
        IDtoInhalt = "Knotenpunkt (LRO)"
    Case 27
        IDtoInhalt = "Knotenpunkt (LRU)"
    Case 28
        IDtoInhalt = "Knotenpunkt (LOU)"
    Case 29
        IDtoInhalt = "Knotenpunkt (ROU)"
    Case 30
        IDtoInhalt = "Brcken-Kreuzung"
End Select
End Function

'Weist jeder ID einen Parameternamen zu
Function IDtoParam1(ByVal ID As Integer) As String
Select Case ID
    Case 1, 4, 7, 8, 10, 14
        IDtoParam1 = "Spannung [V]"
    Case 2, 3, 6, 12, 17
        IDtoParam1 = "Widerstand [Ohm]"
    Case 5
        IDtoParam1 = "[geschlossen = 1]"
    Case 9
        IDtoParam1 = "Leistung [W]"
    Case 11
        IDtoParam1 = "Akt. Widerstand [Ohm]"
    Case 16
        IDtoParam1 = "Kapazitt [F]"
    Case 18
        IDtoParam1 = "Induktivitt [H]"
    Case 19
        IDtoParam1 = "[L = 0, R = 1]"
End Select
End Function

'Weist jeder ID einen Parameternamen zu
Function IDtoParam2(ByVal ID As Integer) As String
Select Case ID
    Case 1
        IDtoParam2 = "Innenwiderstand [Ohm]"
    Case 4, 7
        IDtoParam2 = "Leistung [W]"
    Case 8, 9, 14
        IDtoParam2 = "Stromstrke [A]"
    Case 10
        IDtoParam2 = "Frequenz [Hz]"
    Case 11
        IDtoParam2 = "Ges. Widerstand [Ohm]"
    Case 12
        IDtoParam2 = "Maximallast [W]"
    Case 17
        IDtoParam2 = "Induktivitt [H]"
End Select
End Function

'Weist jeder ID einen Kommentarnamen zu
Function IDtoKommentar(ByVal ID As Integer) As String
Select Case ID
    Case 15
        IDtoKommentar = "Textinhalt"
    Case Else
        IDtoKommentar = "Kommentar"
End Select
End Function

'Weist jeder ID eine Kategorie zu
Function IDtoCat(ByVal ID As Integer) As Byte
Select Case ID
    Case 1 To 6       'Basiselemente
        IDtoCat = 1
    Case 11 To 12, 19 'Spezialformen
        IDtoCat = 2
    Case 10, 16 To 18 'Wechselstromelemente
        IDtoCat = 3
    Case 13 To 14     'Dioden (modelliert)
        IDtoCat = 4
    Case 7 To 9       'Verbraucher allgemein
        IDtoCat = 5
    Case 15           'Sonstiges
        IDtoCat = 10
End Select
End Function

'Fr die Simulation relevante Kategorie-Unterteilung
Function SimIDtoCat(ByVal ID As Byte) As Byte
Select Case ID
    Case 1, 10                       'Stromquellen
        SimIDtoCat = 1
    Case 2 To 9, 11 To 14, 16 To 18  'Normale BauEl
        SimIDtoCat = 2
    Case 20 To 25, 30                'Verbindungen
        SimIDtoCat = 3
    Case 26 To 29, 19                'Knotenpunkte
        SimIDtoCat = 4
End Select
End Function

'Weist jeder ID eine Klasse zu
Function IDtoClass(ByVal ID As Integer) As Byte
Select Case ID
    Case 2 To 14 'Widerstand
        IDtoClass = 1
    Case 16      'Kapazitt
        IDtoClass = 2
    Case 17, 18   'Induktivitt
        IDtoClass = 3
End Select
End Function

'Weist jeder Klasse eine Einheit zu
Function ClassToEinheit(ByVal Class As Byte) As String
Select Case Class
    Case 1
        ClassToEinheit = "Ohm"
    Case 2
        ClassToEinheit = "F"
    Case 3
        ClassToEinheit = "H"
End Select
End Function

'Weist jeder Klasse einen Namen fr die el. Gre zu
Function ClassToName(ByVal Class As Byte) As String
Select Case Class
    Case 1
        ClassToName = "Widerstand"
    Case 2
        ClassToName = "Kapazitt"
    Case 3
        ClassToName = "Induktivitt"
End Select
End Function
