Attribute VB_Name = "modDynLine"
'##### Dynamisches Linienzeichnen #####

Option Explicit

Public PaintLine As tPaintLine          'Zwischenwerte zum dynamischen Linienzeichnen
    Private Type tPaintLine
        c_VZ_Zellen As Integer            'Anzahl temporr bebaute Zellen
        VZ_Zellen(32) As Integer          'Array temporr bebaute Zellen
        Zelle As Integer                  'Anfangszelle
        State As Byte                     'Aktueller Status: 0 = wrde funktionieren; 1 = ... nicht ...
        BuildZellen As Byte               'Bereits finales Bauen der Elemente
    End Type
    
Dim aZ As Integer                'Aktuelle Zelle
Dim n As Integer
Dim Richtung As Byte

'Oberste Sub zum Linienzeichnen (die wird aufgerufen!)
Public Function VerbindeZellen(ByVal Zelle1 As Integer, ByVal Zelle2 As Integer, Optional BuildZellen As Byte) As Boolean
If EZS = 1 Then Exit Function
'Bei BuildZellen = 1 werden die Zellen dauerhaft gebaut - bei 0 temporr
If BuildZellen = 1 Then PrepareBackup Zelle1, Zelle2
PaintLine.BuildZellen = BuildZellen
PaintLine.c_VZ_Zellen = 0
If GetRowByNr(Zelle1) = GetRowByNr(Zelle2) Then     'Horizontale Verbindung
    If GetColByNr(Zelle2) > GetColByNr(Zelle1) Then 'links nach rechts
        Richtung = 1
    Else
        Richtung = 0
    End If
ElseIf GetColByNr(Zelle1) = GetColByNr(Zelle2) Then 'Vertikale Verbindung
    If GetRowByNr(Zelle2) > GetRowByNr(Zelle1) Then 'oben nach unten
        Richtung = 3
    Else
        Richtung = 2
    End If
Else
    Exit Function
End If
aZ = Zelle1
'Startzelle bauen
If GetZellZone(aZ, Richtung) = False Then  'Bauelement nicht passend
    Select Case aZelle(aZ).ID
        Case 0
            VZ_Build GetIDbyDir(Richtung)
        Case 20, 21
            If CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 0 Then
                VZ_Build GetIDbyDir(Richtung)
            ElseIf CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 1 Then
                VZ_Build GetIDbyDir(Richtung, TurnDLeft(Richtung))
            ElseIf CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 2 Then
                VZ_Build GetIDbyDir(Richtung, TurnDRight(Richtung))
            ElseIf CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 3 Then
                VZ_Build GetIDbyDir(Richtung, TurnDLeft(Richtung), TurnDRight(Richtung))
            End If
        Case 22 To 25
            VZ_Build GetIDbyDir(GetDirByID(aZelle(aZ).ID, 1), GetDirByID(aZelle(aZ).ID, 2), Richtung)
        Case Else 'inc. 26 bis 29
            Exit Function
    End Select
End If
'Endzelle bauen
aZ = Zelle2
If GetZellZone(aZ, TurnD(Richtung)) = False Then
    Select Case aZelle(aZ).ID
        Case 0
            VZ_Build GetIDbyDir(Richtung)
        Case 20, 21
            If CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 0 Then
                VZ_Build GetIDbyDir(Richtung)
            ElseIf CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 1 Then
                VZ_Build GetIDbyDir(TurnD(Richtung), TurnDLeft(Richtung))
            ElseIf CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 2 Then
                VZ_Build GetIDbyDir(TurnD(Richtung), TurnDRight(Richtung))
            ElseIf CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 3 Then
                VZ_Build GetIDbyDir(TurnD(Richtung), TurnDLeft(Richtung), TurnDRight(Richtung))
            End If
        Case 22 To 25
            VZ_Build GetIDbyDir(GetDirByID(aZelle(aZ).ID, 1), GetDirByID(aZelle(aZ).ID, 2), TurnD(Richtung))
        Case Else
            ClearTempLine
            Exit Function
    End Select
End If
'Mittlere Zellen
aZ = Zelle1
Do Until aZ = NchsteZelle(Zelle2, TurnD(Richtung))
    aZ = NchsteZelle(aZ, Richtung)
    If CanPaint = 1 Then
        If AllowedToBuilt(aZ) = True Then
            VZ_Build GetIDbyDir(Richtung)
        End If
    ElseIf CanPaint = 0 Then
        ClearTempLine
        Exit Function 'Bauelemente im Weg
    Else 'Bauelement muss gebaut werden (z. B. berbrckung)
        VZ_Build CanPaint
    End If
Loop
VerbindeZellen = True 'Wenn die Funktion noch nicht verlassen wurde, Zeichnen erfolgreich
If BuildZellen = 1 Then SavePreparedBackup "Zellen verbinden"
End Function

'Sub welche die Zelle letztendlich baut; entweder temporr oder dauerhaft
Private Sub VZ_Build(ID As Byte)
If PaintLine.BuildZellen = 1 Then
    frmHaupt.Build aZ, ID, , 1, 1
Else
    PaintLine.c_VZ_Zellen = PaintLine.c_VZ_Zellen + 1
    PaintLine.VZ_Zellen(PaintLine.c_VZ_Zellen) = aZ
    frmHaupt.PaintImage aZ, ID
End If
End Sub

'berprfen eventuell strender Bauelemente zwischen Anfangs- und Zielzelle
Private Function CanPaint() As Byte
Select Case aZelle(aZ).ID
    Case 0
        CanPaint = 1
    Case 19
        If GetZellZone(aZ, Richtung) = True And GetZellZone(aZ, TurnD(Richtung)) = True Then CanPaint = 1
    Case 20, 21
        If GetZellZone(aZ, Richtung) = False Then
            If CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 0 Then
                CanPaint = GetIDbyDir(Richtung)
            ElseIf CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 1 Then
                CanPaint = GetIDbyDir(Richtung, TurnD(Richtung), TurnDLeft(Richtung))
            ElseIf CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 2 Then
                CanPaint = GetIDbyDir(Richtung, TurnD(Richtung), TurnDRight(Richtung))
            ElseIf CheckDirections(TurnDLeft(Richtung), TurnDRight(Richtung)) = 3 Then
                CanPaint = 30
            End If
        Else
            CanPaint = 1
        End If
    Case 22 To 25
        If GetDirByID(aZelle(aZ).ID, 1) = Richtung Or GetDirByID(aZelle(aZ).ID, 1) = TurnD(Richtung) Then
            CanPaint = GetIDbyDir(Richtung, TurnD(Richtung), GetDirByID(aZelle(aZ).ID, 2))
        Else
            CanPaint = GetIDbyDir(Richtung, TurnD(Richtung), GetDirByID(aZelle(aZ).ID, 1))
        End If
    Case 26 To 29
        If GetZellZone(aZ, Richtung) = True And GetZellZone(aZ, TurnD(Richtung)) = True Then CanPaint = 1
    Case Else
        If GetZellZone(aZ, Richtung) = True Then CanPaint = 1 'Alle Bauelemente wo es nicht mglich ist die Richtung zu ndern
End Select
End Function

'Temporr bebaute Zellen wieder lschen
Public Sub ClearTempLine()
For n = 1 To PaintLine.c_VZ_Zellen
    frmHaupt.PaintImage PaintLine.VZ_Zellen(n)
Next
End Sub

'berprfen welche der benachbarten Zelle der Anfangszelle bebaut sind
Private Function CheckDirections(ByVal Dir1 As Byte, ByVal Dir2 As Byte) As Byte '0: keine der Richtungen; 1, 2: diese Richtung bebaut; 3:beide Richtungen bebaut;
If aZelle(NchsteZelle(aZ, Dir1)).ID > 0 And GetZellZone(NchsteZelle(aZ, Dir1), TurnD(Dir1)) = True Then
    Dir1 = 1
Else
    Dir1 = 0
End If
If aZelle(NchsteZelle(aZ, Dir2)).ID > 0 And GetZellZone(NchsteZelle(aZ, Dir2), TurnD(Dir2)) = True Then
    Dir2 = 2
Else
    Dir2 = 0
End If
CheckDirections = Dir1 + Dir2
End Function

'Beenden des Linienzeichenmodus
Public Sub setWorkmode(Optional Zelle As Integer)
frmHaupt.WorkMode = 0
If Zelle > 0 Then
    frmHaupt.ZelleEinlesen Zelle
Else
    frmHaupt.RedrawPic Zelle, 1
    frmHaupt.ZelleEinlesen frmHaupt.mZ
End If
ClearTempLine
End Sub

'berprfung beim Start vom Zeichnen
Public Function CheckAreaA(ByVal Direction As Byte, ByVal X As Integer, ByVal Y As Integer) As Boolean
Const ZoneWidth = 5
Select Case Direction
    Case 0
       If X <= ZoneWidth And Y >= 15.5 - (ZoneWidth / 2) And Y <= 15.5 + (ZoneWidth / 2) Then CheckAreaA = True
    Case 1
       If X >= 31 - ZoneWidth And Y >= 15.5 - (ZoneWidth / 2) And Y <= 15.5 + (ZoneWidth / 2) Then CheckAreaA = True
    Case 2
        If Y <= ZoneWidth And X >= 15.5 - (ZoneWidth / 2) And X <= 15.5 + (ZoneWidth / 2) Then CheckAreaA = True
    Case 3
        If Y >= 31 - ZoneWidth And X >= 15.5 - (ZoneWidth / 2) And X <= 15.5 + (ZoneWidth / 2) Then CheckAreaA = True
End Select
End Function


