Attribute VB_Name = "modHaupt"
'##### Hauptmodul mit globalen Variablen /-typen, der Sub Main und dem ffnen von Dateien #####

Option Explicit

'Typdefinitionen projektbergreifender Datentypen

Type ZellInfoA  'primre Informationen zu jeder Zelle
    ID As Byte           'Bauelement-ID
    AusR As Byte         'Ausrichtung (0 vertikal, 1 horizontal)
    Kommentar As String  'Kommentar
    Param1 As Single     'Parameter 1
    Param2 As Single     'Parameter 2
End Type

Type ObjectsInfo        'Standardwerte der Bauelemente
    Param1 As Single
    Param2 As Single
End Type

'Einstellbare Optionen
Public returnMessage As Byte            'Rckgabemeldung bei Simulation
Public ShowGauge As Byte                'Anzeige Messgerte
Public zWS As Double, b_BzWS As Byte    'Zellenws., Zellenws. fr Bauel.
Public GbLe As Byte, GbLePro As Integer 'Glhbirnen leuchten, Prozentsatz
Public GbDb As Byte, GbDbPro As Integer '"      durchbrennen, "
Public WsDb As Byte, WsDbPro As Integer 'Widerstnde "      , "
Public DbBr As Byte                     'Durchgebranntes berechnen
Public ExpCol As Long, tExpCol As Long  'Exportfarbe, bergabewert
Public GZ As Byte                       'Gltige Ziffern
Public Objects(0 To 19) As ObjectsInfo  'Voreinstellungen der Bauel.

'Projektinformationen
Public aZelle() As ZellInfoA      'Basisinformationen ber alle Zellen (geordnet nach Zellennummern)
Public aZelle_n() As ZellInfoA    'Zwischenspeicherung zum ndern der Gre des Schaltbildes / Verschieben von Zellen
Public hZellen As Integer         'Anzahl hor. Zellen
Public vZellen As Integer         'Anzahl vert. Zellen
Public ProjektName As String      'Name der Schaltung
Public SpeicherOrt As String      'Speicherort der Datei
Public SaveFormat As String       'Gibt das Format der aktuellen Datei an: "e2002" oder "XML"

Public SpeichernDialog As SpeichernDialogInfo 'bergabewerte Speichern-Dialog
Private Type SpeichernDialogInfo
    Pfad As String                'bergabepfad der Datei fr das Dialogfeld Speichern
    datei As String               'bergabewert Dateiname (um das unbenannte Projekt danach zu benennen)
    DirPfad As String             'Pfad zum Verzeichniss
    Cancel As Boolean             'Gibt an, ob das Dialogfeld Speichern abgebrochen wurde
    XSL As Byte                   '1 = Web XSL; 2 = XSL + lokale Daten
End Type

Public DruckenDialog As DruckenDialogInfo 'bergabewerte Drucken-Dialog
Private Type DruckenDialogInfo
    Cancel As Boolean             'Gibt an, ob das Dialogfeld Drucken abgebrochen wurde
End Type

'Umgebungsinformationen
Public OpenFile As Boolean        'Gibt an ob eine Datei geffnet wird
Public SimWin As Byte             'Simulationsfenster
Public PhDiaAct As Byte           'Phasendiagramm aktiv (Oszilloskop)
Public HoldSimWin As Byte         'Zelle halten
Public MessWin As Byte            'Messfenster
Public DiaWin As Byte             'Diagrammfenster
Public CalcAreaWin As Byte        'Markierter Bereich - Ws/Kap Fenster
Public RCWin As Byte              'Schwingkreisfenster
Public SettingsFile As String     'Datei fr die Settings.ini

'Globale Konstanten

Public Const ProgramName = "eXact"       'Programmname
Public Const Ver = "1.10"                'Version
Public Const MaxSize = 32                'Maximale Breite/Hhe
Public Const WSRand = 16                 'Rand innerhalb des Arbeitsbereichs
Public Const c_Toolwin = 3               'Anzahl Toolwins (+1, da ab 0)
Public Const Pi = 3.14159265358979       'Pi
Public Const Farbe_M = &HFF6400          'Markierte Farbe
Public Const Farbe_N = &HFFA05A          'Normale Farbe
 
'Modulintern
Dim n As Integer

'### Start des Programs ###
Sub Main()
'Umgebungsvariablen
SettingsFile = GetAppPath & "Settings.ini"
'Zhler Feedback
KeyErstellen "current_user", "Software\" & ProgramName
If IsNumeric(WertAbfragen("current_user", "Software\" & ProgramName, "Counter")) Then
    n = CInt(WertAbfragen("current_user", "Software\" & ProgramName, "Counter")) + 1
Else
    n = 1
End If
WertErstellen "current_user", "Software\" & ProgramName, "Counter", n
If n = 10 Or n = 20 Or n = 40 Or n = 60 Or (n Mod 100) = 0 Then frmRemindFeedback.Show vbModal
'Dateityp registrieren
If (WertAbfragen("classes_root", "Elektro2002File\shell\open\command", "") = """" & GetAppPath & App.EXEName & ".exe" & """ %1") = False Then
    KeyErstellen "classes_root", "Elektro2002File\shell\open\command"
    KeyErstellen "classes_root", "Elektro2002File\DefaultIcon"
    KeyErstellen "classes_root", ".e2002"
    WertErstellen "classes_root", ".e2002", "", "Elektro2002File"
    WertErstellen "classes_root", "Elektro2002File", "", "Elektro2002 Schaltung"
    WertErstellen "classes_root", "Elektro2002File\DefaultIcon", "", GetAppPath & App.EXEName & ".exe"
    WertErstellen "classes_root", "Elektro2002File\shell\open", "", "ffnen"
    WertErstellen "classes_root", "Elektro2002File\shell\open\command", "", """" & GetAppPath & App.EXEName & ".exe" & """ %1"
End If
'berprfung ob eine Datei geffnet wird
If Len(Command) > 0 And (Left(Command, 1) = "-") = False Then
    SpeicherOrt = Command
    MainOpenFile
Else
    'Firstrun?
    If GetSettingIni(SettingsFile, "main", "nostartup") = "" Then
        frmFirstRun.Show
    Else
        frmNeu.Show
    End If
End If
End Sub

'ffnen einer Datei
Sub MainOpenFile()
On Error GoTo a
frmWait.Show 'Beim Parsen bereits Wait Screen
frmNeu.Hide
DoEvents
ReDim aZelle(0)
If ParseFile(SpeicherOrt) = False Then 'Keine gltige XML Datei, Binary versuchen
    OpenBinaryFile
    SaveFormat = "e2002"
End If
SaveFormat = "xml"
'Erfolgreich!!!
Unload frmNeu
OpenFile = True
frmHaupt.Show
Exit Sub
a:
    Unload frmWait 'Wait Screen doch wieder weg
    frmNeu.Show
    MsgBox "Die Datei kann nicht geffnet werden", , "Fehler"
End Sub

'ffnen einer Binrdatei
Sub OpenBinaryFile()
Open SpeicherOrt For Binary As #1
    Get #1, , aZelle
Close #1
ProjektName = aZelle(0).Kommentar
hZellen = aZelle(0).Param1
vZellen = aZelle(0).Param2
CreateArrays
Open SpeicherOrt For Binary As #1
    Get #1, , aZelle
Close #1
If aZelle(0).AusR < 11 Then 'Altes Dateiformat
    For n = 1 To hZellen * vZellen
        If aZelle(n).ID = 0 Then aZelle(n).AusR = 0
        If aZelle(n).ID >= 22 And aZelle(n).ID <= 30 Then aZelle(n).AusR = 2
    Next
End If
End Sub

'Speichern einer Binrdatei
Sub SaveBinaryFile()
aZelle(0).Kommentar = ProjektName
aZelle(0).Param1 = hZellen
aZelle(0).Param2 = vZellen
aZelle(0).AusR = 11          'Dateiformat ver. 1.1
Open SpeicherOrt For Binary As #1
    Put #1, , aZelle
Close #1
End Sub

'Sub um die Arrays festzulegen
Function CreateArrays()
ReDim aZelle(0 To hZellen * vZellen)
ReDim bZelle(1 To hZellen * vZellen)
ReDim cZelle(1 To hZellen * vZellen)
End Function

'Start des Demos
Sub MainStartDemo()
frmWait.Show
DoEvents
vZellen = 12
hZellen = 12
CreateArrays
ProjektName = "Demo-Projekt"
frmHaupt.Show
DoEvents
frmDemo.Show , frmHaupt
End Sub
