Attribute VB_Name = "modRegistry"
'##### Modul fr Registry Zugriffe (wird fr das Registrieren des Dateityps bentigt) #####

Option Explicit

'Initialisierung der API-FUNKTIONEN
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Dim KeyHandle As Long

Private Function ConvertHKey(ByVal hschlssel As String) As Long
Dim a As Long
hschlssel = LCase(hschlssel)
Select Case hschlssel
    Case "classes_root"
        a = &H80000000
    Case "current_user"
        a = &H80000001
    Case "local_machine"
        a = &H80000002
    Case "users"
        a = &H80000003
    Case "current_config"
        a = &H80000005
    Case "dyn_data"
        a = &H80000006
End Select
ConvertHKey = a
End Function

Sub KeyErstellen(Hauptschlssel, Unterschlssel)
Call RegCreateKey(ConvertHKey(Hauptschlssel), Unterschlssel, KeyHandle)
Call RegCloseKey(KeyHandle)
End Sub

Sub WertErstellen(Hauptschlssel, Unterschlssel, Name, Wert)
Call RegOpenKey(ConvertHKey(Hauptschlssel), Unterschlssel, KeyHandle)
Call RegSetValueEx(KeyHandle, Name, 0, 1, Wert, Len(Wert) + 1)
Call RegCloseKey(KeyHandle)
End Sub

Sub WertLschen(Hauptschlssel, Unterschlssel, Name)
Call RegOpenKey(ConvertHKey(Hauptschlssel), Unterschlssel, KeyHandle)
Call RegDeleteValue(KeyHandle, Name)
Call RegCloseKey(KeyHandle)
End Sub

Sub KeyLschen(Hauptschlssel, Unterschlssel)
Call RegDeleteKey(ConvertHKey(Hauptschlssel), Unterschlssel)
End Sub

Function WertAbfragen(Hauptschlssel, Unterschlssel, Name) As String
Dim x As String * 50000
Dim a As Long
a = 50000
Call RegOpenKey(ConvertHKey(Hauptschlssel), Unterschlssel, KeyHandle)
Call RegQueryValueEx(KeyHandle, Name, 0, 1, x, a)
Call RegCloseKey(KeyHandle)
On Error Resume Next
WertAbfragen = Left(x, a - 1)
If Len(WertAbfragen) = 49999 Then WertAbfragen = ""
End Function
