Attribute VB_Name = "modUndo"
'##### Modul fr Rckgngig/Widerherstellen-Funktionen #####

Option Explicit

Private Type tUndo
    aZelle() As ZellInfoA          'Partialarray mit nderungen
    SpecialAction As String        'Andere nderungen (z. B. Projektname, Schaltbildgre)
End Type

Dim aZelle_preUndo As tUndo        'Vorbereiten des Backups (muss aber nicht durchgefhrt werden)

'Rckgngig:
Dim aZelle_undo(1 To 10) As tUndo  'Speicherung aller gesicherten Partialarrays
'Widerherstellen:
Dim aZelle_redo(0 To 9) As tUndo   'Speicherung aller gesicherten Partialarrays

'Gemeinsam:
Dim UndoNames(0 To 10) As String   'Namen der durchgefhrten Aktionen

Dim UndoPos As Integer   'Aktuelle Undo-Position beim Nutzen der Rckggngig Funktion
Dim CountUndo As Integer 'Anzahl der Undos

Dim n As Integer

Const MaxUndos = 10

Sub InitalizeUndo()
UndoPos = 0
CountUndo = 0
RefreshMenu
End Sub

'Backup vorbereiten
Sub PrepareBackup(ByVal Zelle1 As Integer, Optional ByVal Zelle2 As Integer, Optional SpecialAction As String)
If Zelle1 > Zelle2 Then 'Vertauschen
    n = Zelle1
    Zelle1 = Zelle2
    Zelle2 = n
End If
If Zelle2 = 0 Then Zelle2 = Zelle1
ReDim aZelle_preUndo.aZelle(Zelle1 To Zelle2)
For n = Zelle1 To Zelle2
    aZelle_preUndo.aZelle(n) = aZelle(n)
Next
aZelle_preUndo.SpecialAction = SpecialAction
End Sub

'Backup vorbereiten + speichern
Sub SaveBackup(ActionName As String, ByVal Zelle1 As Integer, Optional ByVal Zelle2 As Integer, Optional SpecialAction As String)
PrepareBackup Zelle1, Zelle2, SpecialAction
SavePreparedBackup ActionName
End Sub

'Backup speichern
Sub SavePreparedBackup(ActionName As String)
If CountUndo > 0 Then
    If UndoPos > 1 Then
        'Es wurde davor Rckgngig benutzt
        If CountUndo > UndoPos Then
            'Undos alle (undopos-1) nach unten schieben
            For n = UndoPos + 1 To CountUndo
                ReDim aZelle_undo(n - (UndoPos - 1)).aZelle(LBound(aZelle_undo(n).aZelle) To UBound(aZelle_undo(n).aZelle))
                aZelle_undo(n - (UndoPos - 1)) = aZelle_undo(n)
                UndoNames(n - (UndoPos - 1)) = UndoNames(n)
            Next
        End If
        CountUndo = CountUndo - UndoPos
    ElseIf UndoPos = 0 Then
        'Alle eins nach oben
        For n = CountUndo + (CountUndo = 10) To 1 Step -1
            ReDim aZelle_undo(n + 1).aZelle(LBound(aZelle_undo(n).aZelle) To UBound(aZelle_undo(n).aZelle))
            aZelle_undo(n + 1) = aZelle_undo(n)
            UndoNames(n + 1) = UndoNames(n)
        Next
    ElseIf UndoPos = 1 Then
        CountUndo = CountUndo - UndoPos
    End If
    'Ergebnis: Undo 1 ist leer und kann jetzt belegt werden
End If
'Aktuelles Speichern
ReDim aZelle_undo(1).aZelle(LBound(aZelle_preUndo.aZelle) To UBound(aZelle_preUndo.aZelle))
aZelle_undo(1).aZelle = aZelle_preUndo.aZelle
aZelle_undo(1).SpecialAction = aZelle_preUndo.SpecialAction
UndoNames(1) = ActionName
UndoPos = 0
If CountUndo < MaxUndos Then CountUndo = CountUndo + 1
RefreshMenu
End Sub

'Bearbeiten Men aktualisieren
Private Sub RefreshMenu()
'Rckgngig
If CountUndo > 0 And UndoPos < CountUndo Then
    frmHaupt.mnuUndo(0).Caption = "Rckgngig: " & UndoNames(UndoPos + 1)
    frmHaupt.mnuUndo(0).Enabled = True
Else
    frmHaupt.mnuUndo(0).Caption = "Rckgngig: nicht mglich"
    frmHaupt.mnuUndo(0).Enabled = False
End If
'Widerherstellen
If UndoPos > 0 Then
    frmHaupt.mnuUndo(1).Caption = "Wiederherstellen: " & UndoNames(UndoPos)
    frmHaupt.mnuUndo(1).Enabled = True
Else
    frmHaupt.mnuUndo(1).Caption = "Wiederherstellen: nicht mglich"
    frmHaupt.mnuUndo(1).Enabled = False
End If
End Sub

'Undo ausfhren
Sub DoUndo()
If CountUndo > UndoPos Then
    UndoPos = UndoPos + 1
    'Schaltbildgre / Projektname
    If Left(aZelle_undo(UndoPos).SpecialAction, 10) = "ChangeSize" Then
        aZelle_redo(UndoPos - 1).SpecialAction = "ChangeSize:" & hZellen & "," & vZellen
        ReDim aZelle_redo(UndoPos - 1).aZelle(1 To UBound(aZelle))
        aZelle_redo(UndoPos - 1).aZelle = aZelle
        SetSize aZelle_undo(UndoPos).SpecialAction
    ElseIf Left(aZelle_undo(UndoPos).SpecialAction, 10) = "ChangeName" Then
        aZelle_redo(UndoPos - 1).SpecialAction = "ChangeName:" & ProjektName
        ProjektName = Right(aZelle_undo(UndoPos).SpecialAction, Len(aZelle_undo(UndoPos).SpecialAction) - 11)
        frmHaupt.Caption = ProjektName & " - " & ProgramName & " " & Ver
    Else
        aZelle_redo(UndoPos - 1).SpecialAction = ""
    End If
    'Redo speichern von dem was jetzt gendert wird!
    If Not Left(aZelle_undo(UndoPos).SpecialAction, 10) = "ChangeSize" Then
        ReDim aZelle_redo(UndoPos - 1).aZelle(LBound(aZelle_undo(UndoPos).aZelle) To UBound(aZelle_undo(UndoPos).aZelle))
        For n = LBound(aZelle_undo(UndoPos).aZelle) To UBound(aZelle_undo(UndoPos).aZelle)
            aZelle_redo(UndoPos - 1).aZelle(n) = aZelle(n)
        Next
    End If
    'Backup einspielen
    For n = LBound(aZelle_undo(UndoPos).aZelle) To UBound(aZelle_undo(UndoPos).aZelle)
        aZelle(n) = aZelle_undo(UndoPos).aZelle(n)
    Next
    frmHaupt.RefreshPics
    frmHaupt.ZelleEinlesen frmHaupt.mZ
    RefreshMenu
End If
End Sub

'Redo ausfhren
Sub DoRedo()
If UndoPos > 0 Then
    UndoPos = UndoPos - 1
    'Projektname / Gre
    If Left(aZelle_redo(UndoPos).SpecialAction, 10) = "ChangeSize" Then
        SetSize aZelle_redo(UndoPos).SpecialAction
    ElseIf Left(aZelle_redo(UndoPos).SpecialAction, 10) = "ChangeName" Then
        ProjektName = Right(aZelle_redo(UndoPos).SpecialAction, Len(aZelle_redo(UndoPos).SpecialAction) - 11)
        frmHaupt.Caption = ProjektName & " - " & ProgramName & " " & Ver
    End If
    For n = LBound(aZelle_redo(UndoPos).aZelle) To UBound(aZelle_redo(UndoPos).aZelle)
        aZelle(n) = aZelle_redo(UndoPos).aZelle(n)
    Next
    frmHaupt.RefreshPics
    frmHaupt.ZelleEinlesen frmHaupt.mZ
    RefreshMenu
End If
End Sub

'Schaltbildgre ndern
Private Sub SetSize(SpecialAction As String)
Dim hZellen_n As Integer, vZellen_n As Integer
hZellen_n = Mid(SpecialAction, InStr(SpecialAction, ":") + 1, InStr(SpecialAction, ",") - InStr(SpecialAction, ":") - 1)
vZellen_n = Mid(SpecialAction, InStr(SpecialAction, ",") + 1, Len(SpecialAction) - InStr(SpecialAction, ","))
frmHaupt.SetSize hZellen_n, vZellen_n, 0, 1
End Sub
